import type { ComboboxAPI, ComboboxStates, HideMsgPropType, IdPropType, InputTypeOnDefault, KoliBriHorizontalIcons, LabelWithExpertSlotPropType, MsgPropType, NamePropType, ShortKeyPropType, Stringified, SuggestionsPropType, SyncValueBySelectorPropType, TooltipAlignPropType } from '../../schema';
import type { JSX } from '../../stencil-public-runtime';
export declare class KolCombobox implements ComboboxAPI {
    private readonly host?;
    private refInput?;
    private refSuggestions;
    private _focusedOptionIndex;
    getValue(): Promise<string | undefined>;
    kolFocus(): Promise<void>;
    private toggleListbox;
    private readonly catchRef;
    private selectOption;
    private onInput;
    private handleKeyDownDropdown;
    private setFilteredSuggestionsByQuery;
    private moveFocus;
    private focusOption;
    private focusSuggestionStartingWith;
    private getFormFieldProps;
    private getInputProps;
    render(): JSX.Element;
    handleKeyDown(event: KeyboardEvent): void;
    private readonly controller;
    private blockSuggestionMouseOver;
    private _isOpen;
    private _filteredSuggestions?;
    handleWindowClick(event: MouseEvent): void;
    _accessKey?: string;
    _placeholder?: string;
    _disabled?: boolean;
    _hideMsg?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: Stringified<KoliBriHorizontalIcons>;
    _id?: IdPropType;
    _label: LabelWithExpertSlotPropType;
    _msg?: Stringified<MsgPropType>;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _suggestions: SuggestionsPropType;
    _required?: boolean;
    _shortKey?: ShortKeyPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tabIndex?: number;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _value?: string;
    state: ComboboxStates;
    private inputHasFocus;
    constructor();
    private showAsAlert;
    validatePlaceholder(value?: string): void;
    validateAccessKey(value?: string): void;
    validateDisabled(value?: boolean): void;
    validateHideMsg(value?: HideMsgPropType): void;
    validateHideLabel(value?: boolean): void;
    validateHint(value?: string): void;
    validateIcons(value?: Stringified<KoliBriHorizontalIcons>): void;
    validateId(value?: string): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMsg(value?: Stringified<MsgPropType>): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSuggestions(value?: SuggestionsPropType): void;
    validateRequired(value?: boolean): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTabIndex(value?: number): void;
    validateTouched(value?: boolean): void;
    validateValue(value?: string): void;
    componentWillLoad(): void;
    handleMouseEvent(): void;
    handleFocusOut(): void;
    handleWindowBlur(): void;
    private onBlur;
    private onChange;
}
